#ifndef STEREO_H
#define STEREO_H

#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cassert>
#include "image.h"
#include "misc.h"
#include "pnmfile.h"
#include "filter.h"
#include "imconv.h"

void dt(float *f);
void msg(float *s1, float *s2, float *s3, float *s4, float *dst);
image<float*> *comp_data(image<uchar> *img1, image<uchar> *img2);
image<uchar> *output(image<float*> *u, image<float*> *d, image<float*> *l,
		image<float*> *r, image<float*> *data);
void bp_cb(image<float*> *u, image<float*> *d, image<float*> *l,
		image<float*> *r, image<float*> *data);
image<uchar> *stereo_ms(image<uchar> *img1, image<uchar> *img2, int iterations,
		int scales, float trunk_disc_cost, float trunk_data_cost,
		float weight_data_cost, float large_cost, int poss_disparities,
		int scaling, double smoothing);
image<float *> * initialize_image(image<float *> *im);
image<float *> * destroy_image(image<float *> *im);

#endif
