#ifndef _ImagePosition_h_
#define _ImagePosition_h_

//
//     Class  ImagePosition ()
//

class ImagePosition
{ 
private:
  Vector _x;  //  ( Z-Vector )
  Matrix _V0; // ʬ
  double _f;  // Υ

public:
  // constructor
  ImagePosition();
  ImagePosition(double x, double y, double f=600.0);
  ImagePosition(const Vector& x, double f=600.0);
  ImagePosition(const Vector& x, const Matrix& V, double f=600.0);

  // copy constructor
  ImagePosition(const ImagePosition&);

  // destructor
  ~ImagePosition(){};

  // assingment operator
  ImagePosition& operator=(const ImagePosition&);

  const Vector&  Pos()  const  { return _x;  }
  const Matrix&  Cov()  const  { return _V0; }
  const double&  Foc()  const  { return _f;  }
  
  void SetPos(double x, double y);
  void SetPos(const Vector& x);
  void SetCov(double dx, double dy = -1.0, double dxy=0.0);
  void SetCov(const MatrixMN& S);
  void SetCov(const Matrix&   V)  { _V0 = V; }
  void SetFoc(double f) { _f = f; }

  void ChangeFoc(double f);
  
  int  Print(FILE *fp = stdout,
		const char* str = "#ImagePosition") const;
  int  LongPrint(FILE *fp = stdout,
		const char* str = "#ImagePosition") const;
  int  Scan(FILE *fp = stdin);
};

#endif  // _ImagePosition_h_

