#include <statcomp.h>
#include <tool.h>
#include "correct.h"
#include "extra.h"


/*
 *3333ƥ󥽥M_hat9ĤθͭVectorN(9)бͭ
 *ľMatrix*, ڤΥ٥οe_hat2Ϳơ
 *ùF, ɸаF_plus, F_minus֤
 *  (PDP = primary deviation pair)
 */

void PDP(int point_num, VectorN eigen_vec, Matrix* eigen_mat, 
	 double e_hat2, Matrix& F, Matrix& F_plus, Matrix& F_minus, 
	 int crr_flag = 1)
{
  /****************************************************************
   *
   *  int       point_num   ǡ                input
   *  VectorN   eigen_vec   M_hat9Ĥθͭ        input
   *                        9٥ȥγ
   *  Matrix    *eigen_mat  M_hat9Ĥθͭ      input
   *                        eigen_vecγǤб
   *  double    e_hat2      Υ٥ο  input
   *  Matrix&   F           ù          output
   *  Matrix&   F_plus      Fɸа               output
   *  Matrix&   F_minus     F                     output
   *  int       crr_flag    Ŭ¹ԥե饰        input
   *                        1ΤȤFκŬ¹
   *                        ǥե: 1
   *
   ****************************************************************/

  int i, j, k, l, m, n, p, q;
  Tensor3333 M_hat, V_0F, W, Pi;


  /******M_hatκǾͭͤбͭFȤ******/
  F = eigen_mat[8]; 


  /******Fʬƥ󥽥V_0F׻******/
  for (int a = 0; a < 8; a++)
    V_0F = V_0F + TensorProduct(eigen_mat[a], eigen_mat[a])/eigen_vec[a];
  V_0F = V_0F/(double)point_num;
  

  /******FdetF=0Ȥʤ褦******/
  if (crr_flag == 1)
    F = Correct(F, V_0F, 1.0e-12);


  /******⡼ȥƥ󥽥M_hat׻ľ******/
  for (int a = 0; a < 8; a++)
    M_hat = M_hat + eigen_vec[a]*TensorProduct(eigen_mat[a], eigen_mat[a]);


  /******ƥ󥽥W׻******/
  Pi = Pseudo(Cofactor(F));
  for (i = 0; i < 3; i++)
    for (j = 0; j < 3; j++)
      for (k = 0; k < 3; k++)
        for (l = 0; l < 3; l++)
          for (m = 0; m < 3; m++)
            for (n = 0; n < 3; n++)
              for (p = 0; p < 3; p++)
                for (q = 0; q < 3; q++)
                  {
                    W(i, j, k, l) = W(i, j, k, l) +
                      Pi(i, j, m, n)*Pi(k, l, p, q)*M_hat(m, n, p, q);
                  }
  

  /******ƥ󥽥W9Ĥθͭͭ͡******/
  VectorN eigen_mu(9);
  Matrix eigen_G[9];
  if (W.Eigen(eigen_mu, eigen_G))
    {
      //ɸаF_plus, F_minus׻
      double mu = sqrt(e_hat2/(eigen_mu[6]*point_num));
      F_plus  = Normalize(F + mu*eigen_G[6]);
      F_minus = Normalize(F - mu*eigen_G[6]);
    }
  else
    {
      printf("Cannot calculate eigenvalues of Tensor 'W'\n");
      exit(1);
    }
}
