IF(LAPACK_FOUND)
	MESSAGE(STATUS "Skipping search for clapack since Lapack has been found")
	RETURN()
ENDIF()

SET(CLAPACK_ROOT_DIR "" CACHE PATH "Path where you have put the clapack libraries")
FIND_LIBRARY(CLAPACK_CBLAS_LIB
	NAMES BLAS blas
	HINTS ${CLAPACK_ROOT_DIR}/BLAS/SRC
	PATH_SUFFIXES Debug Release
)
FIND_LIBRARY(CLAPACK_LIB
	NAMES clapack lapack
	HINTS ${CLAPACK_ROOT_DIR}/SRC
	PATH_SUFFIXES Debug Release
)
FIND_LIBRARY(CLAPACK_F2C_LIB
	NAMES libf2c f2c
	HINTS ${CLAPACK_ROOT_DIR}/F2CLIBS/libf2c
	PATH_SUFFIXES Debug Release
)

INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(clapack DEFAULT_MSG
	CLAPACK_LIB
    CLAPACK_CBLAS_LIB
	CLAPACK_F2C_LIB
)

# libraries and found message compatible to Lapack
SET(LAPACK_FOUND ${CLAPACK_FOUND})
SET(LAPACK_LIBRARIES
	${CLAPACK_CBLAS_LIB}
    ${CLAPACK_LIB}
	${CLAPACK_F2C_LIB}
)
