# Find script for Open Exif

if(USE_OEXIF)

	SET(OEXIF_INCLUDE_DIR ${OEXIF_INCLUDE_DIR})
	FIND_PATH(OEXIF_INCLUDE_DIR openexif)
	FIND_LIBRARY(OEXIF_LIBRARY
		OEXIF_NAMES openexif openexifd
		HINTS ${OEXIF_INCLUDE_DIR}/lib
	)
	FIND_LIBRARY(OEXIF_LIBRARY_JPEG
		OEXIF_NAMES OpenExifJpeg
		HINTS ${OEXIF_INCLUDE_DIR}/lib
	)
	SET(OEXIF_SOURCE_FILES ${OEXIF_SOURCE_FILES} 
	${OEXIF_INCLUDE_DIR}/src/ExifApp0Seg.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifApp0Seg.h
	${OEXIF_INCLUDE_DIR}/src/ExifAppSegManager.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifAppSegManager.h
	${OEXIF_INCLUDE_DIR}/src/ExifAppSegment.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifAppSegment.h
	${OEXIF_INCLUDE_DIR}/src/ExifComMarker.h
	${OEXIF_INCLUDE_DIR}/src/ExifComp.h
	${OEXIF_INCLUDE_DIR}/src/ExifComp.h.in
	${OEXIF_INCLUDE_DIR}/src/ExifConf.h
	${OEXIF_INCLUDE_DIR}/src/ExifDefs.h
	${OEXIF_INCLUDE_DIR}/src/ExifErrorCodes.h
	${OEXIF_INCLUDE_DIR}/src/ExifFileIO.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifFileIO.h
	${OEXIF_INCLUDE_DIR}/src/ExifHuffmanTable.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifHuffmanTable.h
	${OEXIF_INCLUDE_DIR}/src/ExifIFD.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifIFD.h
	${OEXIF_INCLUDE_DIR}/src/ExifIJGWrapper.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifIJGWrapper.h
	${OEXIF_INCLUDE_DIR}/src/ExifIJGWriteFrame.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifIJGWriteFrame.h
	${OEXIF_INCLUDE_DIR}/src/ExifImageDescUtils.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifImageDescUtils.h
	${OEXIF_INCLUDE_DIR}/src/ExifImageFile.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifImageFile.h
	${OEXIF_INCLUDE_DIR}/src/ExifImageFileIO.h
	${OEXIF_INCLUDE_DIR}/src/ExifImageFileRead.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifImageFileWrite.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifInternetIO.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifInternetIO.h
	${OEXIF_INCLUDE_DIR}/src/ExifIO.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifIO.h
	${OEXIF_INCLUDE_DIR}/src/ExifJpegDataDst.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifJpegDataSrc.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifJpegExtn.h
	${OEXIF_INCLUDE_DIR}/src/ExifJpegImage.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifJpegImage.h
	${OEXIF_INCLUDE_DIR}/src/ExifMemoryIO.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifMemoryIO.h
	${OEXIF_INCLUDE_DIR}/src/ExifMisc.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifMisc.h
	${OEXIF_INCLUDE_DIR}/src/ExifOpenFile.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifOpenFile.h
	${OEXIF_INCLUDE_DIR}/src/ExifRawAppSeg.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifRawAppSeg.h
	${OEXIF_INCLUDE_DIR}/src/ExifStripImage.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifStripImage.h
	${OEXIF_INCLUDE_DIR}/src/ExifTagEntry.h
	${OEXIF_INCLUDE_DIR}/src/ExifTags.h
	${OEXIF_INCLUDE_DIR}/src/ExifTiffAppSeg.cpp
	${OEXIF_INCLUDE_DIR}/src/ExifTiffAppSeg.h
	${OEXIF_INCLUDE_DIR}/src/ExifTypeDefs.h
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jcapimin.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jcapistd.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jccoefct.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jccolor.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jcdctmgr.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jchuff.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jchuff.h
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jcinit.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jcmainct.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jcmarker.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jcmaster.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jcomapi.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jconfig.h
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jcparam.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jcphuff.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jcprepct.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jcsample.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdapimin.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdapistd.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdatadst.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdatasrc.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdcoefct.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdcolor.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdct.h
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jddctmgr.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdhuff.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdhuff.h
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdinput.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdmainct.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdmarker.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdmaster.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdmerge.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdphuff.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdpostct.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jdsample.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jerror.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jerror.h
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jfdctflt.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jfdctfst.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jfdctint.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jidctflt.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jidctfst.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jidctint.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jidctred.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jinclude.h
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jmemansi.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jmemmgr.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jmemsys.h
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jmorecfg.h
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jpegint.h
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jquant1.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jquant2.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jutils.cpp
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExif_jversion.h
	${OEXIF_INCLUDE_DIR}/src/OpenExifJpeg/OpenExifJpegLib.h
	)

endif(USE_OEXIF)
