# Find script for gpu-sift

IF(SiftGPU_FIND_QUIETLY)
	SET(_FIND_SiftGPU_ARGS QUIET)
ENDIF(SiftGPU_FIND_QUIETLY)

#FIND_PACKAGE(GLUT ${_FIND_SiftGPU_ARGS})
FIND_PACKAGE(CUDA ${_FIND_SiftGPU_ARGS})

FIND_PATH(SiftGPU_ROOT_DIR license.txt)

IF( SiftGPU_ROOT_DIR )

	FIND_PACKAGE(GLEW ${_FIND_SiftGPU_ARGS})
	
	# find devIL
	FIND_PATH( IL_INCLUDE_DIR devil.h DevIL64.h il.h IL.h
		HINTS ${SiftGPU_ROOT_DIR}/include/IL
	)
	FIND_LIBRARY( IL_LIBRARIES
		NAMES devil DEVIL DevIL DevIL64
		HINTS ${SiftGPU_ROOT_DIR}/lib
		PATHS
		DOC "The DevIL library"
	)

	FIND_PATH(SiftGPU_INCLUDE_DIR SiftGPU.h
		HINTS ${SiftGPU_ROOT_DIR}/src/SiftGPU/
	)
	
	FIND_LIBRARY(SiftGPU_LIBRARY
		NAMES SiftGPU SiftGPU_d
		HINTS ${SiftGPU_ROOT_DIR}/lib
	)
	IF(WINDOWS)
		SET(SiftGPU_DEFINITIONS -DSIFTGPU_DLL)
	ENDIF(WINDOWS)

	IF(CUDA_FOUND)
		SET(SiftGPU_DEFINITIONS ${SiftGPU_DEFINITIONS}
			${GLEW_DEFINTIONS}
			${IL_DEFINTIONS}
			#${GLUT_DEFINTIONS}
			${CUDA_DEFINITIONS}
		)	
		SET(SiftGPU_INCLUDE_DIRS 
			${SiftGPU_INCLUDE_DIR}
			${GLEW_INCLUDE_DIRS}
			${IL_INCLUDE_DIRS}
			#${GLUT_INCLUDE_DIRS}
			${CUDA_INCLUDE_DIRS}
		)			
		SET(SiftGPU_LIBRARIES
			${SiftGPU_LIBRARY}
			${GLEW_LIBRARIES}
			${IL_LIBRARIES}
			#${GLUT_LIBRARIES}
			${CUDA_LIBRARIES}
		)
	ELSE( NOT CUDA_FOUND )
		SET(SiftGPU_DEFINITIONS ${SiftGPU_DEFINITIONS}
			${GLEW_DEFINTIONS}
			${IL_DEFINTIONS}
			#${GLUT_DEFINTIONS}
		)
	
		SET(SiftGPU_INCLUDE_DIRS 
			${SiftGPU_INCLUDE_DIR}
			${GLEW_INCLUDE_DIRS}
			${IL_INCLUDE_DIRS}
			#${GLUT_INCLUDE_DIRS}
		)
			
		SET(SiftGPU_LIBRARIES
			${SiftGPU_LIBRARY}
			${GLEW_LIBRARIES}
			${IL_LIBRARIES}
			#${GLUT_LIBRARIES}
		)
	ENDIF(CUDA_FOUND)
	
ENDIF( SiftGPU_ROOT_DIR )
#ELSE(GLEW_FOUND AND IL_FOUND AND CUDA_FOUND)

	#MESSAGE(STATUS "If IL is not found, you can use the SiftGPU Devil Lib for IL_LIBRARIES, ILU_LIBRARIES and ILUT_LIBRARIES")

#ENDIF(GLEW_FOUND AND IL_FOUND AND CUDA_FOUND)

#ENDIF(GLEW_FOUND AND DevIL_FOUND AND GLUT_FOUND AND CUDA_FOUND)

FIND_PACKAGE_HANDLE_STANDARD_ARGS(SiftGPU
	REQUIRED_VARS SiftGPU_INCLUDE_DIR SiftGPU_LIBRARY)
	
MARK_AS_ADVANCED(SiftGPU_INCLUDE_DIR SiftGPU_LIBRARY)

