/*  Copyright (C) 2010 Jens-Malte Gottfried

 This file is part of Charon.

 Charon is free software: you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Charon is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public License
 along with Charon.  If not, see <http://www.gnu.org/licenses/>.
 */
/** \file FileSequenceReaderInterface.h
 *  Declaration of the interface class FileSequenceReaderInterface
 *  \author Jens-Malte Gottfried
 *  \date 16.04.2010
 */

#ifndef ADJUSTBASEDISPLAYINTERFACE_H
#define ADJUSTBASEDISPLAYINTERFACE_H

#include <string>

/// abstract class to provide functions implemented in AdjustBaseDisplay
/** This is needed to use the functions from the templated class
 *  AdjustBaseDisplay in non-templated objects e.g. in AdjustBaseDisplayPluginGui.
 */
class AdjustBaseDisplayInterface {
	/// add meaningful documentation here!
public:
	virtual void processNew(float alphaL, float alphaR) = 0;
	virtual int getMaxAlphaLeft() =0;
	virtual int getMaxAlphaRight() =0;
};

#endif // ADJUSTBASEDISPLAYINTERFACE_H
