/*  Copyright (C) 2013 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file CalibrationFromIndexedMatrixList.h
 *  Declaration of the parameter class CalibrationFromIndexedMatrixList.
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 25.02.2013
 */

#ifndef _CALIBRATIONFROMINDEXEDMATRIXLIST_H_
#define _CALIBRATIONFROMINDEXEDMATRIXLIST_H_

#ifdef _MSC_VER
#ifdef calibrationfromindexedmatrixlist_EXPORTS
/// Visual C++ specific code
#define calibrationfromindexedmatrixlist_DECLDIR __declspec(dllexport)
#else
#define calibrationfromindexedmatrixlist_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define calibrationfromindexedmatrixlist_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>
#include <charon-utils/CImg.h>
#include <hekate/IndexedMatrix.h>

using namespace cimg_library;

/// Reads out calibration matrixes from indexedmatrixlist
/** Reads out calibration matrixes from indexedmatrixlist
 */
template <typename T>
class calibrationfromindexedmatrixlist_DECLDIR CalibrationFromIndexedMatrixList :
		public TemplatedParameteredObject<T> {
public:
	/// default constructor
	/// \param name          Instance name
	CalibrationFromIndexedMatrixList(const std::string& name = "");

	/// indexedMatrixList
	InputSlot< IndexedMatrixList > indexedMatrixList;

	/// Calibration matrices
	OutputSlot< cimg_library::CImgList<T> > calibrations;


protected:
	/// Update object.
	virtual void execute();
};

#endif // _CALIBRATIONFROMINDEXEDMATRIXLIST_H_
