/*  Copyright (C) 2014 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file CorrespondenceReader.h
 *  Declaration of the parameter class CorrespondenceReader.
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 13.01.2014
 */

#ifndef _CORRESPONDENCEREADER_H_
#define _CORRESPONDENCEREADER_H_

#ifdef _MSC_VER
#ifdef correspondencereader_EXPORTS
/// Visual C++ specific code
#define correspondencereader_DECLDIR __declspec(dllexport)
#else
#define correspondencereader_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define correspondencereader_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>
#include <charon-utils/CImg.h>
#include <hekate/Correspondence.hxx>

/// Read from correspondence file
/** Read from correspondence file
 */
template <typename T>
class correspondencereader_DECLDIR CorrespondenceReader :
		public TemplatedParameteredObject<T> {
public:
	/// default constructor
	/// \param name          Instance name
	CorrespondenceReader(const std::string& name = "");

	/// Read correspondence
	OutputSlot< typename hekate::CorrespondenceList<T> > correspondence;

	/// File to read from
	Parameter< std::string > filename;


protected:
	/// Update object.
	virtual void execute();
};

#endif // _CORRESPONDENCEREADER_H_
