/*  Copyright (C) 2013 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file CreateId.h
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 23.10.2013
 *  Declaraion of parameter class CreateId.
 */
#ifndef _CREATEID_H_
#define _CREATEID_H_

#ifdef _MSC_VER
#ifdef createid_EXPORTS
/// Visual C++ specific code
#define createid_DECLDIR __declspec(dllexport)
#else
#define createid_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define createid_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>

/// Creates vector of ids
/** Creates vector of ids
 */
class createid_DECLDIR CreateId : public ParameteredObject {
public:
	/// default constructor
	/// \param name             instance name
	CreateId(const std::string& name = "");

	/// Ids
	OutputSlot< std::vector<int> > ids;

	/// Ids
	ParameterList< int > id;


protected:
	/// Update object.
	virtual void execute();
};

#endif /* _CREATEID_H_ */
