/*  Copyright (C) 2013 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file DepthEdgeFeaturesInterface.h
 *  Declaration of the parameter class DepthEdgeFeatures.
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 21.02.2013
 */

#ifndef _DEPTHEDGEFEATURESINTERFACE_H_
#define _DEPTHEDGEFEATURESINTERFACE_H_

#ifdef _MSC_VER
#ifdef depthedgefeatures_EXPORTS
/// Visual C++ specific code
#define depthedgefeatures_DECLDIR __declspec(dllexport)
#else
#define depthedgefeatures_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define depthedgefeatures_DECLDIR
#endif

#include <charon-utils/CImg.h>
using namespace cimg_library;

template <typename T>
class DepthEdgeFeaturesInterface{

public:	

	/// Calculate features and return them
	virtual CImgList<float> appendFeatures( const unsigned int index) = 0;

};

#endif