/*  Copyright (C) 2013 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file DepthEdgeFeaturesWrite.h
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 14.10.2013
 *  Declaraion of parameter class DepthEdgeFeaturesWrite.
 */
#ifndef _DEPTHEDGEFEATURESWRITE_H_
#define _DEPTHEDGEFEATURESWRITE_H_

#ifdef _MSC_VER
#ifdef depthedgefeatureswrite_EXPORTS
/// Visual C++ specific code
#define depthedgefeatureswrite_DECLDIR __declspec(dllexport)
#else
#define depthedgefeatureswrite_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define depthedgefeatureswrite_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>
#include <charon-utils/CImg.h>

/// Saves feature images in several CImgLists
/** Saves feature images in CImgLists sperately for every frame. Every frame
 *  has one corresponding *.cimg file containing several CImg objects.
 */
class depthedgefeatureswrite_DECLDIR DepthEdgeFeaturesWrite : public ParameteredObject {
public:
	/// default constructor
	/// \param name             instance name
	DepthEdgeFeaturesWrite(const std::string& name = "");

	/// CImgLists of depth edge features
	InputSlot< std::vector<cimg_library::CImgList<float>> > depthEdgesFeatures;

	/// Path to folder
	Parameter< std::string > filename;


protected:
	/// Update object.
	virtual void execute();
};

#endif /* _DEPTHEDGEFEATURESWRITE_H_ */
