/*  Copyright (C) 2013 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file FileWriterIndexedMatrix.h
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 20.02.2013
 *  Declaraion of parameter class FileWriterIndexedMatrix.
 */
#ifndef _FILEWRITERINDEXEDMATRIX_H_
#define _FILEWRITERINDEXEDMATRIX_H_

#ifdef _MSC_VER
#ifdef filewriterindexedmatrix_EXPORTS
/// Visual C++ specific code
#define filewriterindexedmatrix_DECLDIR __declspec(dllexport)
#else
#define filewriterindexedmatrix_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define filewriterindexedmatrix_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>
#include <charon-utils/CImg.h>
#include <hekate/IndexedMatrix.h>

/// Writes class IndexedMatrixList to txt file
/** Writes class IndexedMatrixList to txt file
 */
class filewriterindexedmatrix_DECLDIR FileWriterIndexedMatrix : public ParameteredObject {
public:
	/// default constructor
	/// \param name             instance name
	FileWriterIndexedMatrix(const std::string& name = "");

	/// IndexedMatrixList
	InputSlot< IndexedMatrixList > indexedMatrices;

	/// File to write IndexedMatrixList
	Parameter< std::string > filename;


protected:
	/// Update object.
	virtual void execute();
};

#endif /* _FILEWRITERINDEXEDMATRIX_H_ */
