/*  Copyright (C) 2013 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file GetIdsOfNonEmtyImages.h
 *  Declaration of the parameter class GetIdsOfNonEmtyImages.
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 21.08.2013
 */

#ifndef _GETIDSOFNONEMTYIMAGES_H_
#define _GETIDSOFNONEMTYIMAGES_H_

#ifdef _MSC_VER
#ifdef getidsofnonemtyimages_EXPORTS
/// Visual C++ specific code
#define getidsofnonemtyimages_DECLDIR __declspec(dllexport)
#else
#define getidsofnonemtyimages_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define getidsofnonemtyimages_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>
#include <charon-utils/CImg.h>

/// Reads an image sequence and determines ids of non empty images
/** Reads an image sequence and determines ids of non empty images
 */
template <typename T>
class getidsofnonemtyimages_DECLDIR GetIdsOfNonEmtyImages :
		public TemplatedParameteredObject<T> {
public:
	/// default constructor
	/// \param name          Instance name
	GetIdsOfNonEmtyImages(const std::string& name = "");

	/// Images with putative emptyness
	InputSlot< cimg_library::CImgList<T> > images;

	/// List of ids of non empty images
	OutputSlot< std::vector<int> > indexList;


protected:
	/// Update object.
	virtual void execute();
};

#endif // _GETIDSOFNONEMTYIMAGES_H_
