/*  Copyright (C) 2012 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file HoughTransformation.hxx
 *  Implementation of the parameter class HoughTransformation.
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 12.11.2012
 */

#ifndef _HOUGHTRANSFORMATION_HXX_
#define _HOUGHTRANSFORMATION_HXX_

#include <charon-core/ParameteredObject.hxx>
#include "HoughTransformation.h"

template <typename T>
HoughTransformation<T>::HoughTransformation(const std::string& name) :
		TemplatedParameteredObject<T>(
			"HoughTransformation", name,
			"<h2>Extracts edges by hough transformation</h2><br>"
			"Extracts edges by hough transformation"
		)
{
	ParameteredObject::_addInputSlot(
		imagePaths, "imagePaths",
		"paths to image folder",
		"vector<string>");

	ParameteredObject::_addOutputSlot(
		edges, "edges",
		"Edges",
		"CImgList<T>");

}

template <typename T>
void HoughTransformation<T>::execute() {
	PARAMETEREDOBJECT_AVOID_REEXECUTION;
	ParameteredObject::execute();

	// your code goes here :-)
}

#endif /* _HOUGHTRANSFORMATION_HXX_ */
