/*  Copyright (C) 2013 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file IndexedMatrixListToCImgList.h
 *  Declaration of the parameter class IndexedMatrixListToCImgList.
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 27.02.2013
 */

#ifndef _INDEXEDMATRIXLISTTOCIMGLIST_H_
#define _INDEXEDMATRIXLISTTOCIMGLIST_H_

#ifdef _MSC_VER
#ifdef indexedmatrixlisttocimglist_EXPORTS
/// Visual C++ specific code
#define indexedmatrixlisttocimglist_DECLDIR __declspec(dllexport)
#else
#define indexedmatrixlisttocimglist_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define indexedmatrixlisttocimglist_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>
#include <charon-utils/CImg.h>
#include <hekate/IndexedMatrix.h>

/// Converts IndexedMatrixList to CImgList
/** Converts IndexedMatrixList to CImgList
 */
template <typename T>
class indexedmatrixlisttocimglist_DECLDIR IndexedMatrixListToCImgList :
		public TemplatedParameteredObject<T> {
public:
	/// default constructor
	/// \param name          Instance name
	IndexedMatrixListToCImgList(const std::string& name = "");

	/// Indexed matrix list
	InputSlot< IndexedMatrixList > indexedMatrixList;

	/// CImgList
	OutputSlot< cimg_library::CImgList<T> > cimgList;


protected:
	/// Update object.
	virtual void execute();
};

#endif // _INDEXEDMATRIXLISTTOCIMGLIST_H_
