/*  Copyright (C) 2009 Julian Coordts

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file lsqnonlinsolver.hxx
 *  Implementation of the parameter class lsqnonlinsolver.
 *  \author Julian Coordts
 *  \date 22.03.2010
 */

#ifndef _LSQNONLINSOLVER_HXX_
#define _LSQNONLINSOLVER_HXX_

#include <hekate/LSqNonLinSolver.hxx>

template <typename T>
lsqnonlinsolver<T>::lsqnonlinsolver(
		const std::string& className,
		const std::string& name,
		const std::string& doc) :
			TemplatedParameteredObject<T>(className, name, doc) {
	ParameteredObject::_addOutputSlot(out, "out",
			"pointer to instance", "lsqnonlinsolver<T>*");
	out = this;
}


template <typename T>
lsqnonlinsolver<T>::~lsqnonlinsolver() {
}

#endif /* _LSQNONLINSOLVER_HXX_ */
