/*  Copyright (C) 2013 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file MergeCorrespondences.h
 *  Declaration of the parameter class MergeCorrespondences.
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 07.03.2013
 */

#ifndef _MERGECORRESPONDENCES_H_
#define _MERGECORRESPONDENCES_H_

#ifdef _MSC_VER
#ifdef mergecorrespondences_EXPORTS
/// Visual C++ specific code
#define mergecorrespondences_DECLDIR __declspec(dllexport)
#else
#define mergecorrespondences_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define mergecorrespondences_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>
#include <charon-utils/CImg.h>
#include <hekate/Correspondence.hxx>

using namespace hekate;
using namespace cimg_library;

/// Merges multiple CorrespondenceLists
/** Merges multiple CorrespondenceLists
 */
template <typename T>
class mergecorrespondences_DECLDIR MergeCorrespondences :
		public TemplatedParameteredObject<T> {
public:
	/// default constructor
	/// \param name          Instance name
	MergeCorrespondences(const std::string& name = "");

	/// Multiple correspondence lists to merge
	InputSlot< CorrespondenceList<T> > correspondences;

	/// Merged correspondences
	OutputSlot< CorrespondenceList<T> > correspodencesMerged;


protected:
	/// Update object.
	virtual void execute();
};

#endif // _MERGECORRESPONDENCES_H_
