/*  Copyright (C) 2009 Moritz Becker

    This file is part of Charon.

    Charon is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Charon is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file 3Dpoints2orderedsequence.h
 *  Declaration of the parameter class 3Dpoints2orderedsequence.
 *  \author Moritz Becker
 *  \date 12.07.2010
 */

#ifndef _POINTS2ORDEREDSEQUENCE_H_
#define _POINTS2ORDEREDSEQUENCE_H_

#if defined(MSVC) && defined(HANDLE_DLL)
#ifdef points2orderedsequence_EXPORTS
/// Visual C++ specific code
#define points2orderedsequence_DECLDIR __declspec(dllexport)
#else
#define points2orderedsequence_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else /* No DLL handling or GCC */
/// Not needed with GCC
#define points2orderedsequence_DECLDIR
#endif

#include <charon-core/ParameteredObject.hxx>
#include <charon-utils/CImg.h>

/// merges two 3D point clouds to a vector<vector<vector<..>>> [index][image1/2][x,y,z,k]
template <typename T>
class points2orderedsequence_DECLDIR points2orderedsequence :
		public TemplatedParameteredObject<T> {
public:
	
	///  
	InputSlot < std::vector<std::vector<T> > > points1;
	///  
	InputSlot < std::vector<std::vector<T> > > points2;
	///  
	OutputSlot < std::vector<std::vector<std::vector<T> > > > points;
	

	/// create a new 3Dpoints2orderedsequence object
	/// \param name          Instance name
	points2orderedsequence(const std::string& name);

	/// Update object.
	virtual void execute();
};

#endif // _3DPOINTS2ORDEREDSEQUENCE_H_



