/*  Copyright (C) 2013 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file SelectIndexedMatrixById.h
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 27.02.2013
 *  Declaraion of parameter class SelectIndexedMatrixById.
 */
#ifndef _SELECTINDEXEDMATRIXBYID_H_
#define _SELECTINDEXEDMATRIXBYID_H_

#ifdef _MSC_VER
#ifdef selectindexedmatrixbyid_EXPORTS
/// Visual C++ specific code
#define selectindexedmatrixbyid_DECLDIR __declspec(dllexport)
#else
#define selectindexedmatrixbyid_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define selectindexedmatrixbyid_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>
#include <charon-utils/CImg.h>
#include <hekate/IndexedMatrix.h>

/// Selects IndexedMatrix by parameter list
/** Selects IndexedMatrix by parameter list
 */
class selectindexedmatrixbyid_DECLDIR SelectIndexedMatrixById : public ParameteredObject {
public:
	/// default constructor
	/// \param name             instance name
	SelectIndexedMatrixById(const std::string& name = "");

	/// IndexedMatrix
	InputSlot< IndexedMatrixList > indexedMatrix;

	/// Selected indexed matrices
	OutputSlot< IndexedMatrixList > indexedMatrixSelected;
	
	/// Indices of matrices to select
	ParameterList< int > indices;


protected:
	/// Update object.
	virtual void execute();
};

#endif /* _SELECTINDEXEDMATRIXBYID_H_ */
