/*  Copyright (C) 2013 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file SortOutPointsByMask.h
 *  Declaration of the parameter class SortOutPointsByMask.
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 24.01.2013
 */

#ifndef _SORTOUTPOINTSBYMASK_H_
#define _SORTOUTPOINTSBYMASK_H_

#ifdef _MSC_VER
#ifdef sortoutpointsbymask_EXPORTS
/// Visual C++ specific code
#define sortoutpointsbymask_DECLDIR __declspec(dllexport)
#else
#define sortoutpointsbymask_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define sortoutpointsbymask_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>
#include <charon-utils/CImg.h>
#include <hekate/Correspondence.hxx>

using namespace hekate;
using namespace cimg_library;

/// Masks correspondences
/** Masks correspondences
 */
template <typename T>
class sortoutpointsbymask_DECLDIR SortOutPointsByMask :
		public TemplatedParameteredObject<T> {
public:
	/// default constructor
	/// \param name          Instance name
	SortOutPointsByMask(const std::string& name = "");

	/// correspondences
	InputSlot< CorrespondenceList<T> > correspondences;
	/// mask
	InputSlot< std::vector< std::string > > mask;

	/// correspondencesOut
	OutputSlot< CorrespondenceList<T> > correspondencesOut;


protected:
	/// Update object.
	virtual void execute();
};

#endif // _SORTOUTPOINTSBYMASK_H_
