/*  Copyright (C) 2012 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file StructureFromMotionGUI.h
 *  Declaration of the parameter class StructureFromMotionGUI.
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 16.04.2012
 */

#ifndef _STRUCTUREFROMMOTIONGUI_H_
#define _STRUCTUREFROMMOTIONGUI_H_

#ifdef _MSC_VER
#ifdef structurefrommotiongui_EXPORTS
/// Visual C++ specific code
#define structurefrommotiongui_DECLDIR __declspec(dllexport)
#else
#define structurefrommotiongui_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define structurefrommotiongui_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>
#include <SfmGui.h>

/// This plugin provides an interface for a typical SFM workflow
/** This plugin provides an interface for a typical SFM workflow. The
 *  functions needed for SFM are given by other plugins as feature detection,
 *  fundamentalMatrix and create3DPointCloud.
 */
template <typename T>
class structurefrommotiongui_DECLDIR StructureFromMotionGUI :
		public TemplatedParameteredObject<T> {
public:
	/// default constructor
	/// \param name          Instance name
	StructureFromMotionGUI(const std::string& name = "");
	~StructureFromMotionGUI();

	SfmGui* gui;

	/// Update object.
	virtual void execute();
};

#endif // _STRUCTUREFROMMOTIONGUI_H_
