/*  Copyright (C) 2012 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file StructureFromMotionGUI.hxx
 *  Implementation of the parameter class StructureFromMotionGUI.
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 16.04.2012
 */

#ifndef _STRUCTUREFROMMOTIONGUI_HXX_
#define _STRUCTUREFROMMOTIONGUI_HXX_

#include <QApplication> 
#include <QThread>
#include <charon-core/ParameteredObject.hxx>
#include "qt/convToPixmap.hxx"
#include "StructureFromMotionGUI.h"

template <typename T>
StructureFromMotionGUI<T>::StructureFromMotionGUI(const std::string& name) :
		TemplatedParameteredObject<T>(
			"StructureFromMotionGUI", name,
			"<h2>This plugin provides an interface for a typical SFM "
			"workflow</h2><br>"
			"This plugin provides an interface for a typical SFM workflow. "
			"The functions needed for SFM are given by other plugins as "
			"feature detection, fundamentalMatrix and create3DPointCloud."
		), gui(0)
{
}

template <typename T>
void StructureFromMotionGUI<T>::execute() {
	PARAMETEREDOBJECT_AVOID_REEXECUTION;
	ParameteredObject::execute();

    gui = new SfmGui();
	//Q_INIT_RESOURCE(icons);
	gui->show();

}

template <typename T>
StructureFromMotionGUI<T>::~StructureFromMotionGUI(){
	if(gui) delete gui;
}

#endif /* _STRUCTUREFROMMOTIONGUI_HXX_ */
