/*  Copyright (C) 2009 Moritz Becker

    This file is part of Charon.

    Charon is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Charon is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file TestdriverEvaluation.h
 *  Declaration of the parameter class TestdriverEvaluation.
 *  \author Moritz Becker
 *  \date 08.02.2011
 */

#ifndef _TESTDRIVEREVALUATION_H_
#define _TESTDRIVEREVALUATION_H_

#if defined(MSVC) && defined(HANDLE_DLL)
#ifdef testdriverevaluation_EXPORTS
/// Visual C++ specific code
#define testdriverevaluation_DECLDIR __declspec(dllexport)
#else
#define testdriverevaluation_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else /* No DLL handling or GCC */
/// Not needed with GCC
#define testdriverevaluation_DECLDIR
#endif

#include <charon-core/ParameteredObject.hxx>
#include <charon-utils/CImg.h>

/// Evaluates 3D reconstruction of given "testdriver" data. Parallelism and orthogonality is tested.
template <typename T>
class testdriverevaluation_DECLDIR TestdriverEvaluation :
		public TemplatedParameteredObject<T> {
public:	

	/// points3D 
	InputSlot < std::vector<std::vector<T> > > points3D;	

	/// create a new TestdriverEvaluation object
	/// \param name          Instance name
	TestdriverEvaluation(const std::string& name);

	/// Update object.
	virtual void execute();
};

#endif // _TESTDRIVEREVALUATION_H_



