#define MATRIX_MAX_ROWS 		655360
#define MATRIX_OUTPUT_COUNT 	(MATRIX_MAX_ROWS / 4 + 1)
#define MATRIX_CONTROL_COUNT 	MATRIX_OUTPUT_COUNT
#define MATRIX_SPLIT_COUNT		512

#define MATRIX_MAX_MERGE		2

#define MATRIX_OUTINDEX_INVALID	(-1)

struct ControlStep1{
	int 	startRow;
	int		numRows;
	int		outIndex;
};

struct ControlStep2{
	int		outIndex[MATRIX_MAX_MERGE];
	int		complete;
};

struct ControlStep{
	union{
		ControlStep1 step1;
		ControlStep2 step2;
		float		 result[4];
	};
};

/*struct ResultPoint{
	float	result[4];
	int		pointIndex;	
	bool	outlier;
};*/

//int InitCUDA();

class GPUTriangulate{

	private:
		float 		*MatricesDevice;
		ControlStep *ControlDevice;
		float		*MulOutputDevice;
		bool		initSuccess;		

	public:
		GPUTriangulate();
		int init();
		int executeStep1(float *Matrices, int matrixCount, ControlStep *Control, int controlCount);
		int	executeStep2(ControlStep *Control, int controlCount);
		~GPUTriangulate();
};

