/*  Copyright (C) 2013 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file Value2String.h
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 27.06.2013
 *  Declaraion of parameter class Value2String.
 */
#ifndef _VALUE2STRING_H_
#define _VALUE2STRING_H_

#ifdef _MSC_VER
#ifdef value2string_EXPORTS
/// Visual C++ specific code
#define value2string_DECLDIR __declspec(dllexport)
#else
#define value2string_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define value2string_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>

/// Converts a value to a vector of strings
/** This module can be used, to assign numbers to the filewriter names.
 */
class value2string_DECLDIR Value2String : public ParameteredObject {
public:
	/// default constructor
	/// \param name             instance name
	Value2String(const std::string& name = "");

	/// Value
	InputSlot< unsigned int > value;

	/// Value saved as a vector of string
	OutputSlot< std::vector<std::string> > names;


protected:
	/// Update object.
	virtual void execute();
};

#endif /* _VALUE2STRING_H_ */
