/*  Copyright (C) 2010 Julian Coordts

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** @file AdjustBaseDisplayPluginGui.h
 *
 */

#ifndef ADJUSTBASEDISPLAYPLUGINGUI_H_
#define ADJUSTBASEDISPLAYPLUGINGUI_H_

#include <QtGui>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <string>
#include <stdio.h>
#include <charon-core/ParameteredObject.hxx>
#include <charon-utils/CImg.h>
#include "ui_AdjustBaseDisplay.h"
#include "AdjustBaseDisplayInterface.h"

class AdjustBaseDisplayInterface;

namespace Ui {
	class AdjustBaseDisplay;
}

class AdjustBaseDisplayPluginGui : public QObject
{
	Q_OBJECT
private:
	QWidget* _window;
	Ui::AdjustBaseDisplay _gui;

	/// pointer to parent FileSequenceReader
	/** May be used e.g. to reexecute the workflow by
	 *  calling the corresponding functions from the
	 *  FileSequenceReader interface.
	 */
	AdjustBaseDisplayInterface* _parent;

public:
	AdjustBaseDisplayPluginGui(AdjustBaseDisplayInterface* parent);
	~AdjustBaseDisplayPluginGui();
	void drawPictures(QPixmap leftImg,
				 QPixmap rightImg);
	
	double _sliderFactor ;
	void mouseMoveEvent(QMouseEvent*);
	

public slots:
	void runWorkflow();
	void setRightValueInt(double x);
	void setLeftValueInt(double x);
	void setRightValueDouble(int x);
	void setLeftValueDouble(int x);
	void setAutoExecute(int state);
};

#endif /* ADJUSTBASEDISPLAYPLUGINGUI_H_ */
