/*  Copyright (C) 2012 Martin Treiber

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	  
	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file FeatureSequenceASIFT.cpp
 *  This file is needed for class FeatureSequenceGPUASIFT to work as a charon plugin.
 *  \author <a href="mailto:martin.treiber.hd@gmx.de">
 *      Martin Treiber</a>
 *  \date 13.03.2012
 */

//This is basically the same as FeatureSequenceasift.cpp by Moritz Becker

/// Class name of the plugin
#define TYPE FeatureSequenceGPUASIFT
#define featuresequence_EXPORTS

#include <hekate/features/FeatureSequenceGPUASIFT.hxx>

/// Creates an instance of the plugin
extern "C" featuresequencegpuasift_DECLDIR ParameteredObject*
		create(const std::string & name, template_type t) {
	switch(t) {
	case ParameteredObject::TYPE_DOUBLE:
		return new TYPE<double>(name);
		break;
	case ParameteredObject::TYPE_FLOAT:
		return new TYPE<float>(name);
		break;
	case ParameteredObject::TYPE_INT:
		return new TYPE<int>(name);
		break;
	default:
		return new TYPE<int>(name);
		break;
	}
}

/// Deletes an instance of the plugin
extern "C" featuresequencegpuasift_DECLDIR void destroy(ParameteredObject * b) {
	delete b;
}

/// Report build configuration to prevent linking of incompatibel runtime libs
extern "C" featuresequencegpuasift_DECLDIR ParameteredObject::build_type getBuildType() {
#ifdef _DEBUG
	return ParameteredObject::DEBUG_BUILD;
#else
	return ParameteredObject::RELEASE_BUILD;
#endif
}
