#include <hekate/IndexedMatrix.h>	
#include <iostream>
#include <stdexcept>

//IndexedMatrix::IndexedMatrix(){int a = 1;}



	void IndexedMatrix::setIndex(const size_t id1, const size_t id2){
		index1 = id1;
		index2 = id2;
	}
	void IndexedMatrix::setIndex(const size_t id1){
		index1 = id1;
		index2 = id1;
	}
	const size_t IndexedMatrix::getIndex1() const{
		return index1;
	}
	const size_t IndexedMatrix::getIndex2() const{
		return index2;
	}

	static std::ostream& operator<< (std::ostream& stream, IndexedMatrix& obj)
	{
		if(obj.size() == 0)
			throw(std::range_error("Matrix size() is zero."));
		
		std::ios_base::fmtflags flgs = stream.flags() ;
		stream.precision(4) ;


		stream	<< std::scientific;
		stream	<< "Index 1: " << obj.getIndex1() << " / Index 2: " << obj.getIndex2() << std::endl;
		for(int i = 0; i < obj.height(); i++)
		{
			for(int j = 0; j < obj.width(); i++)
			{
				stream << "\t" << obj(j,i) ;
			}
			stream << std::endl;
		}
		stream.flags(flgs) ;
		return stream;
	}
	


	/// Get numer of matrices inside the IndexedMatrixList which are not degenerated
	const IndexedMatrixList IndexedMatrixList::getNonDegeneratedList() const
	{

		IndexedMatrixList nonDegList;

		for(size_t i = 0; i < this->size(); i++)
		{
			if(!this->operator[](i).degenerated)
			{
				nonDegList.push_back( this->operator[](i) );
			}
		}

		return nonDegList;

	}


	/// Get numer of matrices inside the IndexedMatrixList which are not degenerated
	const size_t IndexedMatrixList::sizeNonDegenerated() const
	{
		
		size_t sizeOfVector = 0;

		for(size_t i = 0; i < this->size(); i++)
		{
			if(!this->operator[](i).degenerated)
			{
				sizeOfVector++;
			}
			else
				std::cout << "IndexMatrixList::sizeNonDegenerated(): Matrix[" << i << "] is degenerated" << std::endl;
		}

		return sizeOfVector;

	}


	IndexedMatrix& IndexedMatrixList::operator()(size_t i, size_t j)
	{
		for(size_t k = 0; k < this->size(); k++)
		{
			if(this->operator[](k).getIndex1() == i
				&& this->operator[](k).getIndex2() == j)
			{
				return this->operator[](k);
			}
		}
		throw( std::range_error("IndexedMatrixList::operator(): Matrix with index not available.") );
	}
	
	const IndexedMatrix& IndexedMatrixList::operator()(size_t i, size_t j) const
	{
		for(size_t k = 0; k < this->size(); k++)
		{
			if(this->operator[](k).getIndex1() == i
				&& this->operator[](k).getIndex2() == j)
			{
				return this->operator[](k);
			}
		}
		throw( std::range_error("IndexedMatrixList::operator(): Matrix with index not available.") );
	}
	
	IndexedMatrix& IndexedMatrixList::operator()(size_t i)
	{
		for(size_t k = 0; k < this->size(); k++)
		{
			if(this->operator[](k).getIndex1() == i
				&& this->operator[](k).getIndex2() == i)
			{
				return this->operator[](k);
			}
		}
		throw( std::range_error("IndexedMatrixList::operator(): Matrix with index not available.") );
	}
	
	const IndexedMatrix& IndexedMatrixList::operator()(size_t i) const
	{
		for(size_t k = 0; k < this->size(); k++)
		{
			if(this->operator[](k).getIndex1() == i
				&& this->operator[](k).getIndex2() == i)
			{
				return this->operator[](k);
			}
		}
		throw( std::range_error("IndexedMatrixList::operator(): Matrix with index not available.") );
	}
	

	bool IndexedMatrixList::exists(size_t i) const{

		for(size_t k = 0; k < this->size(); k++)
		{
			if(this->operator[](k).getIndex1() == i
				&& this->operator[](k).getIndex2() == i)
			{
				return  true;
			}
		}
		return false;
	}

	
	bool IndexedMatrixList::exists(size_t i, size_t j) const{

		for(size_t k = 0; k < this->size(); k++)
		{
			if(this->operator[](k).getIndex1() == i
				&& this->operator[](k).getIndex2() == j)
			{
				return true;
			}
		}

		return false;
	}
/*
*/
