/*  Copyright (C) 2010 Moritz Becker

    This source code is distributed under the GNU GPL.
*/
/** \file TriangulationHartleySturm.cpp
 *  This file is needed for class TriangulationHartleySturm to work as a plugin.
 *  \author Moritz Becker
 *  \date 26.05.2010
 */

///Class name of the plugin
#define TYPE TriangulationHartleySturm

#include <hekate/triangulation/TriangulationHartleySturm.hxx>

///Creates an instance of the plugin
extern "C" triangulationhartleysturm_DECLDIR ParameteredObject*
		create(const std::string & name, template_type t) {
	switch(t) {
	case ParameteredObject::TYPE_DOUBLE:
		return new TYPE<double>(name);
		break;
	case ParameteredObject::TYPE_FLOAT:
		return new TYPE<float>(name);
		break;
	case ParameteredObject::TYPE_INT:
		return new TYPE<int>(name);
		break;
	default:
		return new TYPE<int>(name);
		break;
	}
}

///Deletes an instance of the plugin
extern "C" triangulationhartleysturm_DECLDIR void destroy(ParameteredObject * b) {
	delete b;
}

/// Report build configuration to prevent linking of incompatibel runtime libs
extern "C" triangulationhartleysturm_DECLDIR ParameteredObject::build_type getBuildType() {
#ifdef _DEBUG
	return ParameteredObject::DEBUG_BUILD;
#else
	return ParameteredObject::RELEASE_BUILD;
#endif
}

